#ifndef __NOATUN_PLAYER__
#define __NOATUN_PLAYER__

#include <kapp.h>
#include <dcopclient.h>
#include "playerinterface.h"

#ifdef HAVE_NOATUN

class NoatunPlayer:public PlayerInterface {  
  
 public:
  NoatunPlayer();
  ~NoatunPlayer();

  virtual void startPlayer();
  virtual void exitPlayer();
  
  virtual void previous();
  virtual void play();
  virtual void pause();
  virtual void stop();
  virtual void next();

  virtual void setVolume(int);
  virtual void setCurrentTime(int);  
  virtual void toggleRepeat();
  virtual void toggleShuffle();
  
  virtual int getVolume();
  virtual int getCurrentTime();
  virtual int getTrackTime();
  virtual QString getTitle();
  virtual bool getRepeat();
  virtual bool getShuffle();
  virtual bool isPlaying();
  virtual bool isPlayerRunning();

  virtual void openFileSelector();
  virtual void playlistClear();
  virtual void playlistAdd(QString);
  virtual void playlistAdd(QStringList);

  virtual Player is() { return NOATUN; }

 private:

  void sendNoParam(QString);
  void sendIntParam(QString, int);
  int callGetInt(QString);

  int getCurrentTimePercent();

  DCOPClient *client;
  bool running;
  int vol;
};

#else

class NoatunPlayer:public PlayerInterface {  
  
 public:
  NoatunPlayer() {}
  ~NoatunPlayer() {}
};

#endif

#endif
