#ifndef __OSDFRAME_H__
#define __OSDFRAME_H__

#include <kcolorbutton.h>
#include <kconfig.h>
#include <klocale.h>
#include <krootpixmap.h>

#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qcolor.h>
#include <qevent.h>
#include <qfont.h>
#include <qfontdialog.h>
#include <qfontmetrics.h>
#include <qframe.h>
#include <qhbox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qradiobutton.h>
#include <qspinbox.h>
#include <qtabwidget.h>
#include <qtimer.h>
#include <qwidget.h>

#include "math.h"

class OSDFrame : public QFrame {

  Q_OBJECT

 public:

  enum { FADE_IN, FADE_WAIT, FADE_OUT, FADE_STOP, OSD_TEST };
  enum { LEFT, RIGHT, TOP, BOTTOM };

  OSDFrame(KConfig *config);
  ~OSDFrame();

  void paintEvent(QPaintEvent *e);
  
  void startSequence(QString t);
  void startDemo();
  void stopDemo();

  QWidget *getConfigurationWidget(QWidget *parent);

  void writeConfig();

 private slots:

  void paint();
  void configChanged();
  void fadeInChanged(int index);
  void fadeOutChanged(int index);
  void fontChanged();

  void readConfig();

 private:
  KRootPixmap *frameRoot;

  QString title;
  int height;
  int width;

  float i;
  int wait;

  QTimer *paintTimer;
  QFont titleFont;

  int effect;
  int source;
  int destination;

  QColor fgColor;
  QColor bgColor;

  QTabWidget *confWidget;
  QCheckBox *osdBox;
  QSpinBox *osdXBox;
  QSpinBox *osdYBox;
  //QSpinBox *osdSizeBox;
  QPushButton *osdFontButton;
  QSpinBox *osdTBox;
  KColorButton *osdFGColorButton;
  KColorButton *osdBGColorButton;

  bool enable;
  int x, y;
  float transparency;

  KConfig *config;
  bool loop;
};

#endif
